import { CreateFavoriteApi, DelFavoriteApi, FavoriteListApi, UpdateFavoriteApi } from "@/api/favorite";
import { alert } from "@/common/common";
import { getFilterData } from "@/common/util";
import Product from "../components/product";
import Search from "@/components/search"
import { Text, View } from "@tarojs/components"
import Taro, { useRouter } from "@tarojs/taro";
import classnames from "classnames";
import { useCallback, useEffect, useRef, useState } from "react";
import CreatePopup from "../components/createPopup";
import UpdatePopup from "../components/updatePopup";
import styles  from './index.module.scss'
import MCheckbox from "@/components/checkbox";
import AddCollection from "@/components/addCollection";


export default () => {

  const router = useRouter()

  //获取收藏夹面料
  const [list, setList] = useState<any[]>([])
  const getFavoriteInfo = () => {
    let arr:any[] = []
    new Array(10).fill("").map((item, index) => {
      arr.push({id:index, code: index})
    })
    setList(arr)
  }

  //获取搜索数据
  const [searchData, setSearchData] = useState('')
  const onSearch = useCallback((e) => {
    setSearchData(() => e)
  }, [])
  useEffect(() => {
    getFavoriteInfo()
  }, [searchData])

  
  //获取选中的id
  const [ids, setIds] = useState<number[]>([])
  const getSelectIds = useCallback((val) => {
    setIds(() => val)
  }, [])

  //全选反选
  const [allSelectStatus, setAllSelectStatus] = useState(false)
  const selectCallBack = useCallback(() => {
    setAllSelectStatus(() => true)
    setSelectStatus(1)
  }, [])
  const colseCallBack = useCallback(() => {
    setAllSelectStatus(() => false)
    setSelectStatus(3)
  }, [])

  const [selectStatus, setSelectStatus] = useState<1|2|3>(3)
  useEffect(() => {
    if(list.length) {
      if(ids.length == list.length) {
        setSelectStatus(1)
        setAllSelectStatus(true)
      } else if ( 0 < ids.length && ids.length < list.length){
        setSelectStatus(2)
        setAllSelectStatus(false)
      } else {
        setSelectStatus(3)
        setAllSelectStatus(false)
      }
    }
  }, [ids, list]) 


  const [collectionShow, setCollectionShow] = useState(false)
  const closeCollection = useCallback(() => {
    setCollectionShow(false)
  }, [])

  const onAdd = () => {

  }

  return (
    <View className={styles.collection_main}>
      <View className={styles.search}>
        <Search  style={{width: '100%'}} debounceTime={300} changeOnSearch={onSearch} placeholder="请输入面料关键词" />
      </View>
      <View className={styles.operation}>
          <View className={styles.operation_check}>
            <MCheckbox status={allSelectStatus} onSelect={() => selectCallBack()} onClose={() => colseCallBack()}/>
            <Text>全选</Text>
          </View>
          <View className={styles.operation_check_right}>
            <Text className={styles.operation_check_move} onClick={() => setCollectionShow(true)}>移动到</Text>
            <Text className={styles.operation_check_cancel}>取消收藏</Text>
          </View>
        </View>
      <View className={styles.class_list}>
        <Product productList={list} onSelectIds={getSelectIds} selectStatus={selectStatus} openCheckBox={true}/>
      </View>
      <AddCollection show={collectionShow} onAdd={onAdd} onClose={closeCollection}/>
    </View>
  )
  }