import Popup from "@/components/popup";
import { Input, ScrollView, Text, View } from "@tarojs/components";
import { memo, useCallback, useMemo, useRef } from "react";
import classnames from "classnames";
import styles  from './index.module.scss'
import TextareaEnhance from "@/components/textareaEnhance";
import { CreateFavoriteApi } from "@/api/favorite";
import { alert } from "@/common/common";

//原因选择
type ReasonInfoParam = {
    show?: boolean, //显示 
    onClose?: () => void, //关闭
    onUpdate?: () => void, //编辑
    onBatchManagement?: () => void, //批量管理
    onDelete?: () => void, //删除

}
export default memo(({show = false, onClose, onUpdate, onBatchManagement, onDelete}: ReasonInfoParam) => {
    const onClickEven = (val) => {
        if (val == 1) {
            onUpdate?.()
        } else if (val == 2) {
            onBatchManagement?.()
        } else {
            onDelete?.()
        }
    }
    return (
        <Popup show={show} onClose={onClose} showTitle={false} >
            <View className={styles.collection_con}>
                <View className={styles.collection_item} onClick={() => onClickEven(1)}>
                    <Text className={classnames(styles.miconfont, 'iconfont icon-bianji')}></Text>
                    <Text className={styles.text}>编辑收藏夹</Text>
                </View>
                <View className={styles.collection_item} onClick={() => onClickEven(2)}>
                    <Text className={classnames(styles.miconfont, 'iconfont icon-fenlei')}></Text>
                    <Text className={styles.text}>批量管理</Text>
                </View>
                <View className={styles.collection_item} onClick={() => onClickEven(3)}>
                    <Text className={classnames(styles.miconfont, 'iconfont icon-shanchu')}></Text>
                    <Text className={styles.text}>删除该收藏夹</Text>
                </View>
            </View>
        </Popup>
    )
})